unit MainModuleUnit;

interface

uses
    Windows,
    Messages,
    SysUtils,
    Classes,
    Forms,
    SxComObj,
    SxDataModule, SxCustShlObj, SxShellFolder, SxShellView, PermanentModuleUnit,
    SxExtractIcon, SxPropertySheetExt, SxExplorerToolbar, SxExplorerMenu,
    SxNamespaceDetails, SxProvider, SxInterfaces, ShlObj, SxConst;

type
  TMainModule = class(TSxModule)
    VirtualFolder: TSxVirtualFolder;
    SysShellView: TSxSysShellView;
    ExtractIcon: TSxExtractIcon;
    ShellPropSheet: TSxShellPropSheetExt;
    SxExplorerToolbar: TSxExplorerToolbar;
    SxExplorerMenu: TSxExplorerMenu;
    SxNamespaceDetails: TSxNamespaceDetails;
    FormShellView: TSxFormShellView;
    procedure SxNamespaceDetailsColumns2GetData(Sender: TSxNamespaceColumn;
      DataGrain: TSxCustomDataGrain; var Data: OleVariant);
    procedure SxNamespaceDetailsColumns1GetData(Sender: TSxNamespaceColumn;
      DataGrain: TSxCustomDataGrain; var Data: OleVariant);
    procedure VirtualFolderGetShellView(Sender: TSxCustomShellFolder;
      var NewShellView: TSxCustomShellView);
    procedure SxNamespaceDetailsColumns3GetData(Sender: TSxNamespaceColumn;
      DataGrain: TSxCustomDataGrain; var Data: OleVariant);
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  end;

implementation

uses ComServ, ExMegaDemoServer_TLB, Controls;

{$R *.DFM}


procedure TMainModule.SxNamespaceDetailsColumns2GetData(
  Sender: TSxNamespaceColumn; DataGrain: TSxCustomDataGrain;
  var Data: OleVariant);
begin
  Data:=DataGrain.Strings.Values[vGrainPath];
end;

procedure TMainModule.SxNamespaceDetailsColumns1GetData(
  Sender: TSxNamespaceColumn; DataGrain: TSxCustomDataGrain;
  var Data: OleVariant);
var
  tempFileStg:IMDFileObj;
begin
  PermanentModule.MDServer.GetRelativeFileStorage(DataGrain.Strings.Values[vGrainPath],tempFileStg);
  Data:=tempFileStg.Size;
end;

procedure TMainModule.VirtualFolderGetShellView(
  Sender: TSxCustomShellFolder; var NewShellView: TSxCustomShellView);
var
  tempGrain:TsxCustomDataGrain;
  tempFileStg:IMDFileObj;
begin
  tempGrain:=Sender.GetFolderGrain;
  try
    if TsxByHandDataGrain(tempGrain).IsRoot or (tempGrain.Name='Stored Files') then
    begin
      NewShellView:=SysShellView;
    end
    else
    begin
      PermanentModule.MDServer.GetRelativeFileStorage(tempGrain.Strings.Values[vGrainPath],tempFileStg);
      if (tempFileStg<>nil) and tempFileStg.ReadOnly then
         NewShellView:=FormShellView
      else
         NewShellView:=SysShellView;
    end;
  finally
    Sender.ReleaseDataGrain(tempGrain);
  end;
end;

procedure TMainModule.SxNamespaceDetailsColumns3GetData(
  Sender: TSxNamespaceColumn; DataGrain: TSxCustomDataGrain;
  var Data: OleVariant);
begin
  Data:='test';
end;

initialization
    RegisterSxDataModule(ComServer,TMainModule);
end.


